"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from bannerify.types import BaseModel
from typing import Any, Dict, Optional, TypedDict
from typing_extensions import NotRequired


class ModificationTypedDict(TypedDict):
    r"""A modification (aka override) to apply to the layer in image"""
    
    name: str
    r"""The layer name of the modification"""
    color: NotRequired[str]
    r"""The color for the modification"""
    src: NotRequired[str]
    r"""The source image for the modification"""
    text: NotRequired[str]
    r"""You can modify the text layer with this field"""
    barcode: NotRequired[str]
    r"""Modify the barcode layer content with this field"""
    qrcode: NotRequired[str]
    r"""Modify the qrcode layer content with this field"""
    chart: NotRequired[Dict[str, Any]]
    r"""Update chart layer's data, follow chart.js data structure"""
    visible: NotRequired[bool]
    r"""Set the visibility of the field"""
    star: NotRequired[float]
    r"""Star value"""
    

class Modification(BaseModel):
    r"""A modification (aka override) to apply to the layer in image"""
    
    name: str
    r"""The layer name of the modification"""
    color: Optional[str] = None
    r"""The color for the modification"""
    src: Optional[str] = None
    r"""The source image for the modification"""
    text: Optional[str] = None
    r"""You can modify the text layer with this field"""
    barcode: Optional[str] = None
    r"""Modify the barcode layer content with this field"""
    qrcode: Optional[str] = None
    r"""Modify the qrcode layer content with this field"""
    chart: Optional[Dict[str, Any]] = None
    r"""Update chart layer's data, follow chart.js data structure"""
    visible: Optional[bool] = None
    r"""Set the visibility of the field"""
    star: Optional[float] = None
    r"""Star value"""
    
